import Queen;
import DummyQueen;

public class Board extends Object
{
	QueenIfc lastQueen;
	int iBoardSize = 1;
	
	public Board(int iNewBoardSize )
	{
		int i = 0;
		iBoardSize = iNewBoardSize;
		
		if (iBoardSize < 1)
			iBoardSize = 1;
		
		lastQueen = new DummyQueen();
		
		for (i=1; i<= iBoardSize; i++)
			lastQueen = new Queen( i, lastQueen, iBoardSize );
	}
		
	public void solve()
	{
		System.out.println();
		System.out.println( "----------" );
		System.out.println( "Solving the QUEEN-PROBLEM for a " + iBoardSize + "x" + iBoardSize + " Board." );
		System.out.println();
		
		if (lastQueen.hasFirstSolution())
		{
			System.out.println( "Each output consists of an array col[1] through col[n],\n"
												+ "where col[i] is the column where the queen in the ith row is placed." );
			
			lastQueen.gatherResult().print();
			
			while (lastQueen.hasNextSolution())
			{
				lastQueen.gatherResult().print();
			}
			
			System.out.println( "No more solutions for the QUEEN-PROBLEM." );
			System.out.println( "----------" );
			System.out.println();

		}
		else
		{
			System.out.println( "There are no Solutions for a " + iBoardSize + "x" + iBoardSize + " Board." );
			System.out.println( "----------" );
			System.out.println();
		}
	}
}